.386
.model flat,stdcall
option casemap:none

include     \masm32\include\windows.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\user32.inc

WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD

include invoke.inc

includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\user32.lib

.data
ClassName   db "SimpleWindowClass",0
AppName     db "Simple Window",0

.data?
hInstance   HINSTANCE ?
CommandLine LPSTR ?

.code

start:

    _invoke GetModuleHandle,NULL
    mov     hInstance,eax
    call    GetCommandLine
    mov     CommandLine,eax
    _invoke WinMain, hInstance,NULL,CommandLine,SW_SHOWDEFAULT
    _invoke ExitProcess,eax

WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD

    LOCAL   wc:WNDCLASSEX
    LOCAL   msg:MSG
    LOCAL   hwnd:HWND
    mov     wc.cbSize,SIZEOF WNDCLASSEX
    mov     wc.style, CS_HREDRAW or CS_VREDRAW
    mov     wc.lpfnWndProc, OFFSET WndProc
    mov     wc.cbClsExtra,NULL
    mov     wc.cbWndExtra,NULL
    push    hInstance
    pop     wc.hInstance
    mov     wc.hbrBackground,COLOR_WINDOW+1
    mov     wc.lpszMenuName,NULL
    mov     wc.lpszClassName,OFFSET ClassName
    _invoke LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    _invoke LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    _invoke RegisterClassEx, addr wc
    _invoke CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
            WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
            CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
            hInst,NULL
    mov     hwnd,eax
    _invoke ShowWindow, hwnd,SW_SHOWNORMAL
    _invoke UpdateWindow, hwnd

    .WHILE  TRUE
        _invoke GetMessage, ADDR msg,NULL,0,0
        .BREAK  .IF (!eax)
        _invoke TranslateMessage, ADDR msg
        _invoke DispatchMessage, ADDR msg
    .ENDW

    mov     eax,msg.wParam
    ret

WinMain ENDP

WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    .IF uMsg==WM_DESTROY
        _invoke PostQuitMessage,NULL

    .ELSE
        _invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
        ret

    .ENDIF
    
    xor eax,eax
    ret

WndProc ENDP

END start

